//
// Virtual method proxy for class 'VirtualObject'
//
class ucxxVP1VirtualObject : public MyVirtualObject
{
  public:
    ucxxVP1VirtualObject(Yehia::Script::Language *lang, Yehia::Script::Namespace *scope, Yehia::Script::Object *instance) {
      inst_ = instance;
      inst_->reference();
      scope_ = scope;
      lang_ = lang;
    }
    virtual void func()  {
      using namespace Yehia;
      using namespace Yehia::Script;
      
      std::list<Any> args;
      args.push_back(inst_->value());
      call_script_function(lang_, scope_, "func", args);
    }
    void ucxxdfl_func() {
      MyVirtualObject::func();
    }
    ~ucxxVP1VirtualObject() {
      inst_->unreference();
      //scope_->unreference();
    }
  private:
    Yehia::Script::Object *inst_;
    MyVirtualObject *cppinst_;
    Yehia::Script::Namespace *scope_;
    Yehia::Script::Language *lang_;
};
//
// Yehia Script interface for namespace mymodule
//
void yehia_ns_mymodule_register(Yehia::Script::Language& lang)
{
  using namespace Yehia::Script;
  using SigC::retype_return;
  using SigC::slot;
  
  ObjectFactory& factory = lang.factory();
  Signature bases;
  
  NamespaceBuilder nsmymodule(factory, lang.root_namespace(), "mymodule");
  
  nsmymodule.add("an_integer", (unsigned long)10);
  nsmymodule.add("a_string", std::string("Hello World!"));
  nsmymodule.method("func", slot(&sqr_func));
  nsmymodule.method("func", slot(&str_add_func));
  nsmymodule.method("func", slot(&caller_func));
  nsmymodule.method("func", slot(&call_method));
  nsmymodule.method("func", slot(&vobj_creator_func));
  ClassBuilder<MySimpleObject> clMySimpleObject(factory, nsmymodule, "MySimpleObject");
  clMySimpleObject.constructor(WrapConstructor0<MySimpleObject>());
  bases.erase(bases.begin(), bases.end());
  bases.push_back(&typeid(SigC::Object));
  ClassBuilder<MyObject> clMyObject(factory, nsmymodule, "MyObject", bases);
  clMyObject.constructor(Constructor0<MyObject>());
  clMyObject.getter("bar", slot(&MyObject::get_bar));
  clMyObject.setter("bar", slot(&MyObject::set_bar));
  clMyObject.getter("foo", slot(&MyObject::get_foo));
  clMyObject.setter("foo", slot(&MyObject::set_foo));
  bases.erase(bases.begin(), bases.end());
  bases.push_back(&typeid(SigC::Object));
  ClassBuilder<MyVirtualObject> clVirtualObject(factory, nsmymodule, "VirtualObject", bases);
  clVirtualObject.constructor(VirtualConstructor0<ucxxVP1VirtualObject>());
  clVirtualObject.method("func", slot((void (MyVirtualObject::*)())&ucxxVP1VirtualObject::ucxxdfl_func));
}

